/********************************************************************
	Rhapsody	: 8.0.6 
	Login		: GB080220
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: Publisher
//!	Generated Date	: Fri, 18, Dec 2015  
	File Path	: DefaultComponent\DefaultConfig\Publisher.cpp
*********************************************************************/

//#[ ignore
#define NAMESPACE_PREFIX

#define _OMSTATECHART_ANIMATED
//#]

//## auto_generated
#include "Publisher.h"
//## operation regSubscriber(Subscriber)
#include "Subscriber.h"
//#[ ignore
#define Default_Publisher_Publisher_SERIALIZE OM_NO_OP

#define Default_Publisher_broadcastMessage_SERIALIZE OM_NO_OP

#define Default_Publisher_regSubscriber_SERIALIZE aomsmethod->addAttribute("pSubscriber", X2ITEM(pSubscriber));
//#]

//## package Default

//## class Publisher
Publisher::~Publisher() {
    NOTIFY_DESTRUCTOR(~Publisher, true);
    cleanUpRelations();
    cancelTimeouts();
}

OMIterator<Subscriber*> Publisher::getItsSubscriberList() const {
    OMIterator<Subscriber*> iter(itsSubscriberList);
    return iter;
}

void Publisher::removeItsSubscriberList(Subscriber* p_Subscriber) {
    if(p_Subscriber != NULL)
        {
            p_Subscriber->_removeItsPublisher(this);
        }
    _removeItsSubscriberList(p_Subscriber);
}

void Publisher::clearItsSubscriberList() {
    OMIterator<Subscriber*> iter(itsSubscriberList);
    while (*iter){
        Subscriber* current = *iter;
        if(current != NULL)
            {
                current->_removeItsPublisher(this);
            }
        iter++;
    }
    _clearItsSubscriberList();
}

bool Publisher::startBehavior() {
    bool done = false;
    done = OMReactive::startBehavior();
    return done;
}

void Publisher::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
    rootState_timeout = NULL;
}

void Publisher::cleanUpRelations() {
    {
        OMIterator<Subscriber*> iter(itsSubscriberList);
        while (*iter){
            Subscriber* current = *iter;
            if(current != NULL)
                {
                    current->_removeItsPublisher(this);
                }
            iter++;
        }
        itsSubscriberList.removeAll();
    }
}

void Publisher::_removeItsSubscriberList(Subscriber* p_Subscriber) {
    NOTIFY_RELATION_ITEM_REMOVED("itsSubscriberList", p_Subscriber);
    itsSubscriberList.remove(p_Subscriber);
}

void Publisher::_clearItsSubscriberList() {
    NOTIFY_RELATION_CLEARED("itsSubscriberList");
    itsSubscriberList.removeAll();
}

Publisher::Publisher(IOxfActive* theActiveContext) {
    NOTIFY_REACTIVE_CONSTRUCTOR(Publisher, Publisher(), 0, Default_Publisher_Publisher_SERIALIZE);
    setActiveContext(theActiveContext, false);
    initStatechart();
    //#[ operation Publisher()
    std::cout << "Publisher added" << std::endl;
    this->startBehavior();
    //#]
}

void Publisher::cancelTimeouts() {
    cancel(rootState_timeout);
}

bool Publisher::cancelTimeout(const IOxfTimeout* arg) {
    bool res = false;
    if(rootState_timeout == arg)
        {
            rootState_timeout = NULL;
            res = true;
        }
    return res;
}

void Publisher::broadcastMessage() {
    NOTIFY_OPERATION(broadcastMessage, broadcastMessage(), 0, Default_Publisher_broadcastMessage_SERIALIZE);
    //#[ operation broadcastMessage()
    OMIterator<Subscriber*> iter(itsSubscriberList);
    while (*iter) {
    
        (*iter)->GEN(evPublish("Message from publisher!"));
    	iter++;
    }
    //#]
}

void Publisher::regSubscriber(const Subscriber* pSubscriber) {
    NOTIFY_OPERATION(regSubscriber, regSubscriber(Subscriber), 1, Default_Publisher_regSubscriber_SERIALIZE);
    //#[ operation regSubscriber(Subscriber)
    
    if (pSubscriber != NULL) {          
    	std::cout << "Publisher: Adding subscriber (" << pSubscriber->getName() << ")" << std::endl;
    	itsSubscriberList.add((Subscriber*)pSubscriber);
    }                                              
    
    std::cout << "Publisher: " << itsSubscriberList.getCount() << " subscriptions" << std::endl;
    //#]
}

void Publisher::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        NOTIFY_TRANSITION_STARTED("0");
        NOTIFY_STATE_ENTERED("ROOT.idle");
        rootState_subState = idle;
        rootState_active = idle;
        rootState_timeout = scheduleTimeout(5000, "ROOT.idle");
        NOTIFY_TRANSITION_TERMINATED("0");
    }
}

IOxfReactive::TakeEventStatus Publisher::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        // State idle
        case idle:
        {
            if(IS_EVENT_TYPE_OF(OMTimeoutEventId))
                {
                    if(getCurrentEvent() == rootState_timeout)
                        {
                            NOTIFY_TRANSITION_STARTED("2");
                            cancel(rootState_timeout);
                            NOTIFY_STATE_EXITED("ROOT.idle");
                            NOTIFY_STATE_ENTERED("ROOT.publishing");
                            rootState_subState = publishing;
                            rootState_active = publishing;
                            rootState_timeout = scheduleTimeout(1000, "ROOT.publishing");
                            NOTIFY_TRANSITION_TERMINATED("2");
                            res = eventConsumed;
                        }
                }
            else if(IS_EVENT_TYPE_OF(evSubscribe_Default_id))
                {
                    OMSETPARAMS(evSubscribe);
                    NOTIFY_TRANSITION_STARTED("1");
                    cancel(rootState_timeout);
                    NOTIFY_STATE_EXITED("ROOT.idle");
                    NOTIFY_STATE_ENTERED("ROOT.registering");
                    pushNullTransition();
                    rootState_subState = registering;
                    rootState_active = registering;
                    //#[ state registering.(Entry) 
                    regSubscriber(params->aSubscriber);
                    //#]
                    NOTIFY_TRANSITION_TERMINATED("1");
                    res = eventConsumed;
                }
            
        }
        break;
        // State publishing
        case publishing:
        {
            if(IS_EVENT_TYPE_OF(OMTimeoutEventId))
                {
                    if(getCurrentEvent() == rootState_timeout)
                        {
                            NOTIFY_TRANSITION_STARTED("3");
                            cancel(rootState_timeout);
                            //#[ state publishing.(Exit) 
                            broadcastMessage();
                            //#]
                            NOTIFY_STATE_EXITED("ROOT.publishing");
                            NOTIFY_STATE_ENTERED("ROOT.idle");
                            rootState_subState = idle;
                            rootState_active = idle;
                            rootState_timeout = scheduleTimeout(5000, "ROOT.idle");
                            NOTIFY_TRANSITION_TERMINATED("3");
                            res = eventConsumed;
                        }
                }
            
        }
        break;
        // State registering
        case registering:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("4");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.registering");
                    NOTIFY_STATE_ENTERED("ROOT.idle");
                    rootState_subState = idle;
                    rootState_active = idle;
                    rootState_timeout = scheduleTimeout(5000, "ROOT.idle");
                    NOTIFY_TRANSITION_TERMINATED("4");
                    res = eventConsumed;
                }
            
        }
        break;
        default:
            break;
    }
    return res;
}

#ifdef _OMINSTRUMENT
//#[ ignore
void OMAnimatedPublisher::serializeRelations(AOMSRelations* aomsRelations) const {
    aomsRelations->addRelation("itsSubscriberList", false, false);
    {
        OMIterator<Subscriber*> iter(myReal->itsSubscriberList);
        while (*iter){
            aomsRelations->ADD_ITEM(*iter);
            iter++;
        }
    }
}

void OMAnimatedPublisher::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case Publisher::idle:
        {
            idle_serializeStates(aomsState);
        }
        break;
        case Publisher::publishing:
        {
            publishing_serializeStates(aomsState);
        }
        break;
        case Publisher::registering:
        {
            registering_serializeStates(aomsState);
        }
        break;
        default:
            break;
    }
}

void OMAnimatedPublisher::registering_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.registering");
}

void OMAnimatedPublisher::publishing_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.publishing");
}

void OMAnimatedPublisher::idle_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.idle");
}
//#]

IMPLEMENT_REACTIVE_META_P(Publisher, Default, Default, false, OMAnimatedPublisher)
#endif // _OMINSTRUMENT

/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\Publisher.cpp
*********************************************************************/
