/********************************************************************
	Rhapsody	: 8.0.6 
	Login		: GB080220
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: Subscriber
//!	Generated Date	: Fri, 18, Dec 2015  
	File Path	: DefaultComponent\DefaultConfig\Subscriber.cpp
*********************************************************************/

//#[ ignore
#define NAMESPACE_PREFIX

#define _OMSTATECHART_ANIMATED
//#]

//## auto_generated
#include "Subscriber.h"
//## operation addPublisher(Publisher)
#include "Publisher.h"
//#[ ignore
#define Default_Subscriber_Subscriber_SERIALIZE aomsmethod->addAttribute("pName", x2String(pName));

#define OM_Default_Subscriber_Subscriber_1_SERIALIZE OM_NO_OP

#define Default_Subscriber_addPublisher_SERIALIZE aomsmethod->addAttribute("pPublisher", X2ITEM(pPublisher));
//#]

//## package Default

//## class Subscriber
Subscriber::Subscriber(char* pName, IOxfActive* theActiveContext) : name (pName) {
    NOTIFY_REACTIVE_CONSTRUCTOR(Subscriber, Subscriber(char*), 1, Default_Subscriber_Subscriber_SERIALIZE);
    setActiveContext(theActiveContext, false);
    initStatechart();
    //#[ operation Subscriber(char*)
    this->startBehavior();
    //#]
}

Subscriber::~Subscriber() {
    NOTIFY_DESTRUCTOR(~Subscriber, true);
    cleanUpRelations();
    cancelTimeouts();
}

OMIterator<Publisher*> Subscriber::getItsPublisher() const {
    OMIterator<Publisher*> iter(itsPublisher);
    return iter;
}

void Subscriber::removeItsPublisher(Publisher* p_Publisher) {
    if(p_Publisher != NULL)
        {
            p_Publisher->_removeItsSubscriberList(this);
        }
    _removeItsPublisher(p_Publisher);
}

void Subscriber::clearItsPublisher() {
    OMIterator<Publisher*> iter(itsPublisher);
    while (*iter){
        Publisher* current = *iter;
        if(current != NULL)
            {
                current->_removeItsSubscriberList(this);
            }
        iter++;
    }
    _clearItsPublisher();
}

bool Subscriber::startBehavior() {
    bool done = false;
    done = OMReactive::startBehavior();
    return done;
}

void Subscriber::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
    rootState_timeout = NULL;
}

void Subscriber::cleanUpRelations() {
    {
        OMIterator<Publisher*> iter(itsPublisher);
        while (*iter){
            Publisher* current = *iter;
            if(current != NULL)
                {
                    current->_removeItsSubscriberList(this);
                }
            iter++;
        }
        itsPublisher.removeAll();
    }
}

void Subscriber::cancelTimeouts() {
    cancel(rootState_timeout);
}

bool Subscriber::cancelTimeout(const IOxfTimeout* arg) {
    bool res = false;
    if(rootState_timeout == arg)
        {
            rootState_timeout = NULL;
            res = true;
        }
    return res;
}

void Subscriber::_removeItsPublisher(Publisher* p_Publisher) {
    NOTIFY_RELATION_ITEM_REMOVED("itsPublisher", p_Publisher);
    itsPublisher.remove(p_Publisher);
}

void Subscriber::_clearItsPublisher() {
    NOTIFY_RELATION_CLEARED("itsPublisher");
    itsPublisher.removeAll();
}

Subscriber::Subscriber(IOxfActive* theActiveContext) : name("DefaultSubscriber") {
    NOTIFY_REACTIVE_CONSTRUCTOR(Subscriber, Subscriber(), 0, OM_Default_Subscriber_Subscriber_1_SERIALIZE);
    setActiveContext(theActiveContext, false);
    initStatechart();
}

void Subscriber::addPublisher(const Publisher* pPublisher) {
    NOTIFY_OPERATION(addPublisher, addPublisher(Publisher), 1, Default_Subscriber_addPublisher_SERIALIZE);
    //#[ operation addPublisher(Publisher)
    
    if (pPublisher != NULL) {
    	itsPublisher.add((Publisher*)pPublisher);  
    
    	((Publisher*)pPublisher)->GEN(evSubscribe(this));
    }
    //#]
}

char* Subscriber::getName() const {
    return name;
}

void Subscriber::setName(char* p_name) {
    name = p_name;
}

void Subscriber::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        NOTIFY_TRANSITION_STARTED("0");
        NOTIFY_STATE_ENTERED("ROOT.idle");
        rootState_subState = idle;
        rootState_active = idle;
        NOTIFY_TRANSITION_TERMINATED("0");
    }
}

IOxfReactive::TakeEventStatus Subscriber::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        // State idle
        case idle:
        {
            if(IS_EVENT_TYPE_OF(evPublish_Default_id))
                {
                    OMSETPARAMS(evPublish);
                    NOTIFY_TRANSITION_STARTED("1");
                    NOTIFY_STATE_EXITED("ROOT.idle");
                    NOTIFY_STATE_ENTERED("ROOT.recevingMessages");
                    rootState_subState = recevingMessages;
                    rootState_active = recevingMessages;
                    //#[ state recevingMessages.(Entry) 
                    std::cout << this->getName() << ": " << params->msg << std::endl;
                    //#]
                    rootState_timeout = scheduleTimeout(10, "ROOT.recevingMessages");
                    NOTIFY_TRANSITION_TERMINATED("1");
                    res = eventConsumed;
                }
            
        }
        break;
        // State recevingMessages
        case recevingMessages:
        {
            if(IS_EVENT_TYPE_OF(OMTimeoutEventId))
                {
                    if(getCurrentEvent() == rootState_timeout)
                        {
                            NOTIFY_TRANSITION_STARTED("2");
                            cancel(rootState_timeout);
                            NOTIFY_STATE_EXITED("ROOT.recevingMessages");
                            NOTIFY_STATE_ENTERED("ROOT.idle");
                            rootState_subState = idle;
                            rootState_active = idle;
                            NOTIFY_TRANSITION_TERMINATED("2");
                            res = eventConsumed;
                        }
                }
            
        }
        break;
        default:
            break;
    }
    return res;
}

#ifdef _OMINSTRUMENT
//#[ ignore
void OMAnimatedSubscriber::serializeAttributes(AOMSAttributes* aomsAttributes) const {
    aomsAttributes->addAttribute("name", x2String(myReal->name));
}

void OMAnimatedSubscriber::serializeRelations(AOMSRelations* aomsRelations) const {
    aomsRelations->addRelation("itsPublisher", false, false);
    {
        OMIterator<Publisher*> iter(myReal->itsPublisher);
        while (*iter){
            aomsRelations->ADD_ITEM(*iter);
            iter++;
        }
    }
}

void OMAnimatedSubscriber::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case Subscriber::idle:
        {
            idle_serializeStates(aomsState);
        }
        break;
        case Subscriber::recevingMessages:
        {
            recevingMessages_serializeStates(aomsState);
        }
        break;
        default:
            break;
    }
}

void OMAnimatedSubscriber::recevingMessages_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.recevingMessages");
}

void OMAnimatedSubscriber::idle_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.idle");
}
//#]

IMPLEMENT_REACTIVE_META_P(Subscriber, Default, Default, false, OMAnimatedSubscriber)
#endif // _OMINSTRUMENT

/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\Subscriber.cpp
*********************************************************************/
